#include <gtk/gtk.h>
#include <string.h>
#include <filtermenu.h>
#include <filter.h>
#include <cls.h>
#ifdef HAVE_CONFIG_H
#include <config.h>
#endif
#include <jmp-config.h>

static void set_filter_recursive (GtkObject *object) {
    char* str;
    GtkMenuItem* gmi = GTK_MENU_ITEM (object);
    GtkLabel* label = GTK_LABEL (GTK_BIN (gmi)->child);
    gtk_label_get(label, &str);
    filter_set_filter (FILTER_MATCH_RECURSIVE, str);
}

static void set_filter_class (GtkObject *object) {
    char* str;
    GtkMenuItem* gmi = GTK_MENU_ITEM (object);
    GtkLabel* label = GTK_LABEL (GTK_BIN (gmi)->child);
    gtk_label_get(label, &str);
    filter_set_filter (FILTER_MATCH_CLASS, str);
}

static void set_filter_no_filter (GtkObject *object) {
    filter_set_filter (FILTER_MATCH_ALL, "");
}

GtkWidget* build_filter_menu (cls* c) {
    GtkWidget* filters;
    GtkWidget* menuitem;
    char* i;

    /* Quick select of filter.... */
    filters = gtk_menu_new ();
    
    /* No filter. */
    menuitem = gtk_menu_item_new_with_label (_("No filter"));
    gtk_menu_append (GTK_MENU (filters), menuitem);
    gtk_widget_show (menuitem);
    gtk_signal_connect_object (GTK_OBJECT (menuitem), "activate",
			       GTK_SIGNAL_FUNC (set_filter_no_filter),
			       NULL);    

    /* A recursive filter for each package type. */
    i = c->name;       
    while ((i = index (i, '.'))) {
	*i = '\0';
	menuitem = gtk_menu_item_new_with_label (c->name);
	gtk_menu_append (GTK_MENU (filters), menuitem);
	gtk_widget_show (menuitem);
	gtk_signal_connect_object (GTK_OBJECT (menuitem), "activate",
				   GTK_SIGNAL_FUNC (set_filter_recursive),
				   GTK_OBJECT (menuitem));
	*i = '.';
	i++;
    }
    
    /* And a filter for the selected class. */
    menuitem = gtk_menu_item_new_with_label (c->name);
    gtk_menu_append (GTK_MENU (filters), menuitem);
    gtk_widget_show (menuitem);
    gtk_signal_connect_object (GTK_OBJECT (menuitem), "activate",
			       GTK_SIGNAL_FUNC (set_filter_class),
			       GTK_OBJECT (menuitem));
    
    return filters;
}
