#include <methodtime.h>

/** Check if a methodtime is zero 
 * @param mt the methodtime to check.
 * @return true if all time values of mt is zero.
 */
int methodtime_is_zero (methodtime* mt) {
    return mt->tv_sec == 0 &&
	mt->tv_usec == 0 &&
	mt->tv_sec_hold == 0 &&
	mt->tv_usec_hold == 0;
}

/** Add two methodtimes correctly (tv_usec, tv_usec_hold < 1000000) 
 *  res = t1 + t2
 * @param res the result.
 * @param t1 the first time.
 * @param t2 the second time.
 */
void methodtime_add (methodtime* res, methodtime* t1, methodtime* t2) {
    res->tv_sec = t1->tv_sec + t2->tv_sec;
    res->tv_usec = t1->tv_usec + t2->tv_usec;
    if (res->tv_usec > 1000000) {
	res->tv_sec++;
	res->tv_usec -= 1000000;
    }
}
