#ifndef METHODTIME_H__
#define METHODTIME_H__

#include <jni.h>
#include <jvmpi.h>
#include <jmp.h>

/** This is a placeholder for the time taken by a method.
 */
struct methodtime {
    long tv_sec;         /* seconds */
    long tv_sec_hold;    /* taken by submethod */
    long tv_usec;        /* microseconds */
    long tv_usec_hold;   /* taken by submethod */
    jmethodID method_id; /* The id of the method running. */
};

/** Check if a methodtime is zero 
 * @param mt the methodtime to check.
 * @return true if all time values of mt is zero.
 */
int methodtime_is_zero (methodtime* mt);

/** Add two methodtimes correctly (tv_usec, tv_usec_hold < 1000000) 
 *  res = t1 + t2
 *  It is safe to use t1 or t2 as res.
 * 
 * @param res the result.
 * @param t1 the first time.
 * @param t2 the second time.
 */
void methodtime_add (methodtime* res, methodtime* t1, methodtime* t2);



#endif /* METHODTIME_H__ */
