/** 
 * TimerStack a stack that holds methodtimes.
 */
#ifndef TIMERSTACK_H__
#define TIMERSTACK_H__

#include <jmp.h>
#include <method.h>
#include <methodtime.h>

typedef struct stack_node stack_node;

struct stack_node {
    jmethodID method_id;
    long calls;
    methodtime time_taken;    
    stack_node* parent;
    stack_node* siebling;
    stack_node* first_child;
};

struct timerstack {
    methodtime* times;
    stack_node* stack_node;
    size_t top;
    size_t max;
};

/** Create a new stack with a minimun size of size. 
 *  This stack will be expanded as needed.
 */
timerstack* timerstack_new (size_t size);

/** Delete the given stack. */
void   timerstack_free (timerstack* s);

/** Expand the given stack. */
void timerstack_expand (timerstack* s);
#endif /* TIMERSTACK_H__ */
